//+------------------------------------------------------------------+
//|                                               Advers_taktika.mq4 |
//|                                                           AVMOHR |
//+------------------------------------------------------------------+
#property copyright "AVMOHR"
#property link      ""

#property indicator_chart_window

extern int History=3000;
extern string rem1="      ZZ";
extern bool end_ZZ=false;
extern int ExtDepth_Big_ZZ=240;
extern int ExtDeviation_Big_ZZ=5;
extern int ExtBackstep_Big_ZZ=3;

extern int ExtDepth_Small_ZZ=12;
extern int ExtDeviation_Small_ZZ=5;
extern int ExtBackstep_Small_ZZ=3;

extern color Color1=Red;
extern color Color2=Maroon;
extern color Color4=Red;
extern color Color3=Yellow;
double ZigZag_Value[10];                                     //    
int    ZigZag_Candel[10];   

double Delta_Channel; //    ( )
double Delta2;        //     2   
double Delta4;        //     4   
int Delta_1_3;     //    1  3  
int Delta_S_4;     //    1  3  
int Sakral_Point=0;
bool Forse_Trend=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
ObjectCreate("Target_Line",OBJ_TREND,0,0,0,0,0);  //  
 ObjectCreate("Trend_Line",OBJ_TREND,0,0,0,0,0);  //  
 ObjectCreate("Target_Line_ST",OBJ_TREND,0,0,0,0,0);  //       
 ObjectCreate("Trend_Line_ST",OBJ_TREND,0,0,0,0,0);   //       
  ObjectCreate("Target",OBJ_TREND,0,0,0,0,0);         //   ( 6)
   ObjectCreate("Line_1_4",OBJ_CHANNEL,0,0,0,0,0,0,0);  //    1-4-3
    ObjectCreate("Sakral_Line",OBJ_VLINE,0,0,0);          //  
ObjectSet("Target_Line",OBJPROP_COLOR, Color1);
ObjectSetText("Target_Line"," ",10,"Arial",Color1);
ObjectSet("Trend_Line",OBJPROP_COLOR, Color1);
ObjectSetText("Trend_Line"," ",10,"Arial",Color1);
ObjectSet("Line_1_4",OBJPROP_COLOR, Color4);
ObjectSet("Line_1_4",OBJPROP_STYLE, STYLE_DOT);
ObjectSet("Target_Line_ST",OBJPROP_COLOR, Color2);
ObjectSet("Trend_Line_ST",OBJPROP_COLOR, Color2);
ObjectSet("Target_Line_ST",OBJPROP_STYLE, STYLE_DOT);
ObjectSet("Trend_Line_ST",OBJPROP_STYLE, STYLE_DOT);

ObjectSet("Sakral_Line",OBJPROP_COLOR, Color1);
ObjectSetText("Sakral_Line"," ",10,"Arial",Color1);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0, OBJ_TEXT);   //     .  ,            
   ObjectDelete("Target_Line");
   ObjectDelete("Trend_Line");
   ObjectDelete("Line_1_4");
   ObjectDelete("Target");
   ObjectDelete("Target_Line_ST");
   ObjectDelete("Trend_Line_ST");
   ObjectDelete("Sakral_Line");
   ObjectDelete("Sakral_Line_Target1");
   ObjectDelete("Sakral_Line_Target2");
   ObjectDelete("Sakral_Line_4");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   int Total_Big_Wave = Refresh_Wave("Big_Wave",
                                           ExtDepth_Big_ZZ,     //  
                                           ExtDeviation_Big_ZZ, //  
                                           ExtBackstep_Big_ZZ,  //  
                                           0,               //  
                                           History          //  
                                           );
//----
int i_Big_Wave=-1;
while (i_Big_Wave <=1)              //     
  {
   i_Big_Wave++;
   string Name=i_Big_Wave+"_Big_Wave";
   datetime Time1=iTime(NULL,0, ZigZag_Candel[i_Big_Wave]);
   double Prise1=ZigZag_Value[i_Big_Wave]-15*Point;
   if (iClose(NULL,0,ZigZag_Value[i_Big_Wave]) <= Prise1) Prise1=Prise1+35*Point;
   ObjectCreate(Name,OBJ_TEXT,0,0,0);
   ObjectSet(Name,OBJPROP_TIME1,Time1);
   ObjectSet(Name,OBJPROP_PRICE1,Prise1);
   string Text=" ";
   if (end_ZZ)
   {
   switch(i_Big_Wave)
          {
          case 2: Text="  (1)"; break;
          }
    }
    if (!end_ZZ)
    {
         switch(i_Big_Wave)
          {
          case 1: Text="  (1)"; break;
          }
   }
ObjectSetText(Name, Text, 12, "Arial", Color3);   
}

if (end_ZZ)
 {
 int start_range=ZigZag_Candel[1]-1;
 int stop_range=ZigZag_Candel[2]+1;
 }
if (!end_ZZ)
 {
  start_range=ZigZag_Candel[0]-1;
  stop_range=ZigZag_Candel[1]+1;
 }
  
int Total_Small_Wave = Refresh_Wave("Small_Wave",
                                           ExtDepth_Small_ZZ,     //  
                                           ExtDeviation_Small_ZZ, //  
                                           ExtBackstep_Small_ZZ,  //  
                                           start_range,         //  
                                           stop_range          //  
                                           );
if (Total_Small_Wave <= 2) 
 {
 Comment("    . 4   .","\n",
         "     ");
 return(0);
 }
 int Total=6;
while (Total_Small_Wave >= Total)     //     6,   
{
ExtDepth_Small_ZZ++;
Total_Small_Wave = Refresh_Wave("Small_Wave",
                                           ExtDepth_Small_ZZ,     //  
                                           ExtDeviation_Small_ZZ, //  
                                           ExtBackstep_Small_ZZ,  //  
                                           start_range,         //  
                                           stop_range          //  
                                           );
 if ( (Total <=6 
     && ZigZag_Value[0] > ZigZag_Value[2] && ZigZag_Value[1] > ZigZag_Value[3] && ZigZag_Value[2] > ZigZag_Value[4] && ZigZag_Value[3] > ZigZag_Value[5])
      || 
     (Total <=6 
     && ZigZag_Value[0] < ZigZag_Value[2] && ZigZag_Value[1] < ZigZag_Value[3] && ZigZag_Value[2] < ZigZag_Value[4] && ZigZag_Value[3] < ZigZag_Value[5])
       )
     Total=6;
 else Total=4;
}
int i_Small_Wave=0;
while (i_Small_Wave <= Total_Small_Wave)           //     
  {
    Name=i_Small_Wave+"_Small_Wave";
    Time1=iTime(NULL,0, ZigZag_Candel[i_Small_Wave]);
    Prise1=ZigZag_Value[i_Small_Wave];
   if (iClose(NULL,0,ZigZag_Candel[i_Small_Wave]) < Prise1) Prise1=Prise1+15*Point;
   ObjectCreate(Name,OBJ_TEXT,0,0,0);
   ObjectSet(Name,OBJPROP_TIME1,Time1);
   ObjectSet(Name,OBJPROP_PRICE1,Prise1);
   Text=i_Small_Wave;
  if (Total_Small_Wave ==3)
  {
   switch(i_Small_Wave)
          {
          case 0: Text="(4)"; break;
          case 1: Text="(3)"; break;
          case 2: Text="(2)"; break;
          case 3: Text="(1)"; break;
          }
    coordinates(0, 1, 2, 3);
   }
   
  if (Total_Small_Wave == 4)
  {
   switch(i_Small_Wave)
          {
          case 0: Text="(5)"; break;
          case 1: Text="(4)"; break;
          case 2: Text="(3)"; break;
          case 3: Text="(2)"; break;
          case 4: Text="(1)"; break;
          }
    coordinates(1, 2, 3, 4);
   }
  if (Total_Small_Wave == 5)
  {
   switch(i_Small_Wave)
          {
          case 0: Text="(6)"; break;
          case 1: Text="(5)"; break;
          case 2: Text="(4)"; break;
          case 3: Text="(3)"; break;
          case 4: Text="(2)"; break;
          case 5: Text="(1)"; break;
          }
  coordinates(2, 3, 4, 5); 
  }
   ObjectSetText(Name, Text, 12, "Arial", Color1);
   i_Small_Wave++;
}


   return(0);
  }
//+------------------------------------------------------------------+

int Refresh_Wave(string Name,
                 int ExtDepth,     //  
                 int ExtDeviation, //  
                 int ExtBackstep,  //  
                 int Start,           //  
                 int Stop             //  
                 )
{
 int Step_Wave=Start+1;
 int i_zz=-1;
 while (Step_Wave <= Stop)
  {
     double ZZ_Value=iCustom(NULL,0,"ZigZag",ExtDepth,ExtDeviation,ExtBackstep,0,Step_Wave);
     if (ZZ_Value !=0)
       {
       i_zz++;
       ZigZag_Value[i_zz]=ZZ_Value;                                     //  
       ZigZag_Candel[i_zz]=Step_Wave;                                   //  
       }
  Step_Wave++;
  }  //  while 
  return(i_zz);
}

void coordinates(int Target_0, int Target_1, int Target_2, int Target_3)
{
 if (ZigZag_Value[Target_0] > ZigZag_Value[Target_2] && ZigZag_Value[Target_1] > ZigZag_Value[Target_3]) 
  {
  datetime Time1_Target=iTime(NULL,0, ZigZag_Candel[Target_2]);
  datetime Time2_Target=iTime(NULL,0, ZigZag_Candel[Target_0]);
  double Prise1_Target=ZigZag_Value[Target_2];
  double Prise2_Target=ZigZag_Value[Target_0];
  
   datetime  Time1_Trend=iTime(NULL,0, ZigZag_Candel[Target_3]);
   datetime  Time2_Trend=iTime(NULL,0, ZigZag_Candel[Target_1]);
   double  Prise1_Trend=ZigZag_Value[Target_3];
   double  Prise2_Trend=ZigZag_Value[Target_1];
    
    datetime    Time1_Line_1_4=iTime(NULL,0, ZigZag_Candel[Target_3]);
    datetime    Time2_Line_1_4=iTime(NULL,0, ZigZag_Candel[Target_0]);
    datetime   Time3_Line_1_4=iTime(NULL,0, ZigZag_Candel[Target_1]);
    double    Prise1_Line_1_4=ZigZag_Value[Target_3];
    double    Prise2_Line_1_4=ZigZag_Value[Target_0];
    double    Prise3_Line_1_4=ZigZag_Value[Target_1];
 }
 
if (ZigZag_Value[Target_0] < ZigZag_Value[Target_2] && ZigZag_Value[Target_1] < ZigZag_Value[Target_3]) 
 {
  Time1_Target=iTime(NULL,0, ZigZag_Candel[Target_2]);
  Time2_Target=iTime(NULL,0, ZigZag_Candel[Target_0]);
  Prise1_Target=ZigZag_Value[Target_2];
  Prise2_Target=ZigZag_Value[Target_0];
    Time1_Trend=iTime(NULL,0, ZigZag_Candel[Target_3]);
    Time2_Trend=iTime(NULL,0, ZigZag_Candel[Target_1]);
    Prise1_Trend=ZigZag_Value[Target_3];
    Prise2_Trend=ZigZag_Value[Target_1];
        Time1_Line_1_4=iTime(NULL,0, ZigZag_Candel[Target_3]);
        Time2_Line_1_4=iTime(NULL,0, ZigZag_Candel[Target_0]);
        Time3_Line_1_4=iTime(NULL,0, ZigZag_Candel[Target_1]);
        Prise1_Line_1_4=ZigZag_Value[Target_3];
        Prise2_Line_1_4=ZigZag_Value[Target_0];
        Prise3_Line_1_4=ZigZag_Value[Target_1];
 } 
 // -------------------------------------------------      
 ObjectSet("Target_Line",OBJPROP_TIME1,Time1_Target);
 ObjectSet("Target_Line",OBJPROP_TIME2,Time2_Target);
 ObjectSet("Target_Line",OBJPROP_PRICE1,Prise1_Target);
 ObjectSet("Target_Line",OBJPROP_PRICE2,Prise2_Target);
 ObjectSet("Trend_Line",OBJPROP_TIME1,Time1_Trend);
 ObjectSet("Trend_Line",OBJPROP_TIME2,Time2_Trend);
 ObjectSet("Trend_Line",OBJPROP_PRICE1,Prise1_Trend);
 ObjectSet("Trend_Line",OBJPROP_PRICE2,Prise2_Trend);
 // -------------------------------------------------   
    ObjectSet("Line_1_4",OBJPROP_TIME1,Time1_Line_1_4);
    ObjectSet("Line_1_4",OBJPROP_TIME2,Time2_Line_1_4);
    ObjectSet("Line_1_4",OBJPROP_TIME3,Time3_Line_1_4);
    ObjectSet("Line_1_4",OBJPROP_PRICE1,Prise1_Line_1_4);
    ObjectSet("Line_1_4",OBJPROP_PRICE2,Prise2_Line_1_4);
    ObjectSet("Line_1_4",OBJPROP_PRICE3,Prise3_Line_1_4);
 // -------------------------------------------------          
 ObjectSet("Target_Line_ST",OBJPROP_TIME1,Time2_Target);
 ObjectSet("Target_Line_ST",OBJPROP_TIME2,Time1_Target);
 ObjectSet("Target_Line_ST",OBJPROP_PRICE1,Prise2_Target);
 ObjectSet("Target_Line_ST",OBJPROP_PRICE2,Prise1_Target);
 ObjectSet("Trend_Line_ST",OBJPROP_TIME1,Time2_Trend);
 ObjectSet("Trend_Line_ST",OBJPROP_TIME2,Time1_Trend);
 ObjectSet("Trend_Line_ST",OBJPROP_PRICE1,Prise2_Trend);
 ObjectSet("Trend_Line_ST",OBJPROP_PRICE2,Prise1_Trend); 
 
 Delta_Channel=MathAbs( Prise3_Line_1_4 - ObjectGetValueByShift("Line_1_4",ZigZag_Candel[Target_1])); //   
 Delta2= MathAbs( Prise1_Target - ObjectGetValueByShift("Trend_Line",ZigZag_Candel[Target_2]));       //     2   
 Delta4= MathAbs( Prise2_Target - ObjectGetValueByShift("Trend_Line",ZigZag_Candel[Target_0]));       //     4   

string Coment_Text="    "+"\n"+
        "  :"+"\n"+
        "ExtDepth_Big_ZZ = "+ ExtDepth_Big_ZZ+"\n"+
        "ExtDepth_Small_ZZ = "+ ExtDepth_Small_ZZ+"\n";
Comment(Coment_Text);
if (Delta4 <= Delta2)
 Comment(Coment_Text,"\n", "    .    . ","\n");
if (Delta4 > Delta2)            //   ,   
{   
int i=0;    
if ( ObjectGetValueByShift("Target_Line",0) > (ObjectGetValueByShift("Line_1_4",0)) ) 
 while ( ObjectGetValueByShift("Target_Line",i) < (ObjectGetValueByShift("Line_1_4",i)+Delta_Channel) )    i--;
if ( ObjectGetValueByShift("Target_Line",0) < (ObjectGetValueByShift("Line_1_4",0)) ) 
 while ( ObjectGetValueByShift("Target_Line",i) > (ObjectGetValueByShift("Line_1_4",i)-Delta_Channel) )    i--;

  double Target=ObjectGetValueByShift("Target_Line",i);
  Coment_Text=Coment_Text+"  6   "+Target+"\n";
  ObjectSet("Target",OBJPROP_TIME1,iTime(NULL,0,10));
  ObjectSet("Target",OBJPROP_TIME2,iTime(NULL,0,0));
  ObjectSet("Target",OBJPROP_PRICE1,Target);
  ObjectSet("Target",OBJPROP_PRICE2,Target);
  ObjectSet("Target",OBJPROP_COLOR,Color3);
  ObjectSet("Target",OBJPROP_WIDTH,3);
  ObjectSetText("Target","  6,  "+Target,10,"Arial",Color3);
} 
i=1;
if ( ObjectGetValueByShift("Trend_Line_ST",Time1_Target) > (ObjectGetValueByShift("Target_Line_ST",Time1_Target)) ) 
  while ( ObjectGetValueByShift("Trend_Line_ST",i) >= (ObjectGetValueByShift("Target_Line_ST",i)) )    i++;
if ( ObjectGetValueByShift("Trend_Line_ST",Time1_Target) < (ObjectGetValueByShift("Target_Line_ST",Time1_Target)) ) 
  while ( ObjectGetValueByShift("Trend_Line_ST",i) <= (ObjectGetValueByShift("Target_Line_ST",i)) )    i++;
  
Sakral_Point = i;
Delta_1_3 = ZigZag_Candel[Target_3]-ZigZag_Candel[Target_1];
Delta_S_4 = ZigZag_Candel[Target_3]-ZigZag_Candel[Target_0] + Sakral_Point;

if ( Sakral_Point < Delta_1_3 ) 
{
Forse_Trend=true;
Coment_Text = Coment_Text+"--   --"+"\n";
}
else Coment_Text = Coment_Text+"--   --"+"\n";
ObjectSet("Sakral_Line",OBJPROP_TIME1,iTime(NULL,0,ZigZag_Candel[Target_3]+Sakral_Point));
ObjectSet("Sakral_Line_Target1",OBJPROP_TIME1,iTime(NULL,0,ZigZag_Candel[Target_0]-Sakral_Point));

  Comment(Coment_Text);
  

}